<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet
version="1.0"
xmlns:d="http://docbook.org/ns/docbook"
xmlns:xl="http://www.w3.org/1999/xlink"
xmlns:html="http://www.w3.org/1999/xhtml"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--
module :
traitement d'une rfrence bibliographique (biblioentry)

update :
$Id$
fplod 2008-05-15T09:18:54Z aedon.locean-ipsl.upmc.fr (Darwin)
correction on separators between authors for bibtex
fplod 2008-05-14T08:51:10Z aedon.locean-ipsl.upmc.fr (Darwin)
introducting bibtex (latex) output
fplod 2008-05-13T15:24:49Z aedon.locean-ipsl.upmc.fr (Darwin)
add parameter type (default raw)
fplod 2008-05-13T09:17:14Z aedon.locean-ipsl.upmc.fr (Darwin)
bibliomisc is written after biblioid
fplod 2008-05-07T09:06:53Z aedon.locean-ipsl.upmc.fr (Darwin)
improvements for conference
fplod 2008-05-06T09:35:00Z aedon.locean-ipsl.upmc.fr (Darwin)
add category choices
fplod 2008-04-29T15:41:56Z aedon.locean-ipsl.upmc.fr (Darwin)
chgt for dbk5 in
fplod 2008-04-29T09:10:31Z aedon.locean-ipsl.upmc.fr (Darwin)
chgt for dbk5 out
fplod 2007-06-20T17:18:02Z aedon.locean-ipsl.upmc.fr (Darwin)
<bibliomisc role="id"> replaced by <biblioid class="doi">
fplod 2007-05-16T14:01:44Z aedon.locean-ipsl.upmc.fr (Darwin)
correction in order to write doi only once
fplod 2007-05-16T10:27:34Z aedon.locean-ipsl.upmc.fr (Darwin)
remove biblioentry/date and publisher
add biblioentry/biblioset/bibliomisc
fplod 2007-05-15T07:37:46Z aedon.locean-ipsl.upmc.fr (Darwin)
factorisation de biblioentry
fplod 2007-05-14T15:48:04Z aedon.locean-ipsl.upmc.fr (Darwin)
correction to add biblioentry/date (replace biblioentry/biblioset/pubdate)
when "in press"
fplod 2007-05-04T07:59:34Z aedon.locean-ipsl.upmc.fr (Darwin)
factorisation de bibnemomaf01_xml.xsl, bibnemomaf02_xml.xsl,bibnemomaf04_xml.xsl
-->

<xsl:include href="correction_db.xsl"/>
<xsl:include href="category_form.xsl"/>
<xsl:include href="message_lang.xsl"/>

<xsl:template name="one_biblioentry">
 <xsl:param name="visu_modif"/>
 <xsl:param name="type"/>
 <xsl:param name="my_biblioentry"/>
 <xsl:choose>
  <xsl:when test="$type = 'bibtex'">
   <xsl:choose>
    <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='journal']">
     <xsl:text>@article{</xsl:text>
    </xsl:when>
    <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='conference']">
     <xsl:text>@inproceedings{</xsl:text>
    </xsl:when>
    <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='book']">
     <xsl:text>@book{</xsl:text>
    </xsl:when>
    <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='manual']">
     <xsl:text>@manual{</xsl:text>
    </xsl:when>
    <xsl:otherwise>
     <xsl:message terminate="yes">
eee : unknown biblioset 1 relation for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
eee : <xsl:value-of select="$my_biblioentry/descendant::d:biblioset/@relation"/>
     </xsl:message>
    </xsl:otherwise>
   </xsl:choose>
   <xsl:value-of select="$my_biblioentry/@xml:id"/>
  </xsl:when> <!-- end of bibtex specific header for biblioentry -->
 </xsl:choose>
 <xsl:element name="listitem">
  <xsl:element name="para">
   <xsl:choose>
    <xsl:when test="$type = 'bibtex'">
     <xsl:apply-templates select="$my_biblioentry/d:authorgroup" mode="bibtex"/>
    </xsl:when>
    <xsl:otherwise>
     <xsl:apply-templates select="$my_biblioentry/d:authorgroup" mode="raw"/>
    </xsl:otherwise>
   </xsl:choose>
   <xsl:if test="$my_biblioentry/descendant::d:pubdate">
    <xsl:choose>
     <xsl:when test="$type = 'bibtex'">
      <xsl:apply-templates select="$my_biblioentry/descendant::d:pubdate" mode="bibtex"/>
     </xsl:when>
     <xsl:otherwise>
      <xsl:apply-templates select="$my_biblioentry/descendant::d:pubdate" mode="raw"/>
     </xsl:otherwise>
    </xsl:choose>
   </xsl:if>
    <xsl:if test="$my_biblioentry/descendant::d:date">
     <xsl:apply-templates select="$my_biblioentry/descendant::d:date"/>
    </xsl:if>
   <xsl:choose>
    <xsl:when test="$type = 'bibtex'">
     <xsl:apply-templates select="$my_biblioentry/d:title" mode="bibtex"/>
    </xsl:when>
    <xsl:otherwise>
     <xsl:apply-templates select="$my_biblioentry/d:title" mode="raw"/>
    </xsl:otherwise>
   </xsl:choose>
    <xsl:choose>
     <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='journal']">
      <xsl:choose>
       <xsl:when test="$type = 'bibtex'">
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:title" mode="bibtex"/>
       </xsl:when>
       <xsl:otherwise>
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:title" mode="raw"/>
       </xsl:otherwise>
      </xsl:choose>
      <xsl:if test="$my_biblioentry/descendant::d:publishername">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:publishername" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:publishername" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
      <xsl:if test="$my_biblioentry/descendant::d:publisher/d:address">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publisher/d:address" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publisher/d:address" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
      <xsl:if test="$my_biblioentry/descendant::d:volumenum">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:volumenum" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:volumenum" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
       <xsl:if test="$my_biblioentry/descendant::d:issuenum">
        <xsl:choose>
         <xsl:when test="$type = 'bibtex'">
          <xsl:apply-templates select="$my_biblioentry/descendant::d:issuenum" mode="bibtex"/>
         </xsl:when>
         <xsl:otherwise>
          <xsl:apply-templates select="$my_biblioentry/descendant::d:issuenum" mode="raw"/>
         </xsl:otherwise>
        </xsl:choose>
        </xsl:if>
       </xsl:if>
      <xsl:if test="$my_biblioentry/descendant::d:pagenums">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
      <xsl:if test="$my_biblioentry/d:biblioid">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/d:biblioid" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
        <xsl:apply-templates select="$my_biblioentry/d:biblioid" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
      <xsl:if test="$my_biblioentry/descendant::d:biblioset/child::d:bibliomisc">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:bibliomisc" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:bibliomisc" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
     </xsl:when>
     <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='conference']">
      <xsl:choose>
       <xsl:when test="$type = 'bibtex'">
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset[@relation='conference']/child::d:title" mode="bibtex"/>
       </xsl:when>
       <xsl:otherwise>
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:title" mode="raw"/>
       </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:conftitle"/>
      <xsl:if test="$my_biblioentry/descendant::d:biblioset/descendant::d:confnum">
       <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:confnum"/>
      </xsl:if>
      <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:confdates"/>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:address" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/descendant::d:address" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      <xsl:if test="$my_biblioentry/descendant::d:pagenums">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
     </xsl:when>
     <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='book']">
      <xsl:choose>
       <xsl:when test="$type = 'bibtex'">
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset[@relation='book']/child::d:title" mode="bibtex"/>
       </xsl:when>
       <xsl:otherwise>
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:title" mode="raw"/>
       </xsl:otherwise>
      </xsl:choose>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      <xsl:if test="$my_biblioentry/descendant::d:pagenums">
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:pagenums" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:if>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioid" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioid" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
      </xsl:when>
     <xsl:when test="$my_biblioentry/descendant::d:biblioset[@relation='manual']">
      <xsl:choose>
       <xsl:when test="$type = 'bibtex'">
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset[@relation='manual']/child::d:title" mode="bibtex"/>
       </xsl:when>
       <xsl:otherwise>
        <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioset/child::d:title" mode="raw"/>
       </xsl:otherwise>
      </xsl:choose>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioid" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:biblioid" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
     </xsl:when>
     <xsl:otherwise>
      <xsl:message terminate="no">
eee : unknown biblioset 2 relation for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
eee : <xsl:value-of select="$my_biblioentry/descendant::d:biblioset/@relation"/>
      </xsl:message>
       <xsl:choose>
        <xsl:when test="$type = 'bibtex'">
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="bibtex"/>
        </xsl:when>
        <xsl:otherwise>
         <xsl:apply-templates select="$my_biblioentry/descendant::d:publishername" mode="raw"/>
        </xsl:otherwise>
       </xsl:choose>
     </xsl:otherwise>
    </xsl:choose>
  </xsl:element>
  <xsl:if test="$visu_modif= 'modif'">
   <xsl:call-template name="correction">
    <xsl:with-param name="id" select="$my_biblioentry/@xml:id"/>
   </xsl:call-template>
  </xsl:if>
  <xsl:if test="$visu_modif= 'category'">
   <xsl:call-template name="category">
    <xsl:with-param name="id" select="$my_biblioentry/@xml:id"/>
   </xsl:call-template>
  </xsl:if>
 </xsl:element>
 <xsl:choose>
  <xsl:when test="$type = 'bibtex'">
  <xsl:text>}</xsl:text>
  </xsl:when>
 </xsl:choose>
</xsl:template>

<xsl:template match="d:authorgroup" mode="raw">
 <xsl:apply-templates select="d:author" mode="raw"/>
 <xsl:apply-templates select="d:corpauthor" mode="raw"/>
</xsl:template>

<xsl:template match="d:authorgroup" mode="bibtex">
 <xsl:text>, </xsl:text>
 <xsl:text>author = {</xsl:text>
 <xsl:apply-templates select="d:author" mode="bibtex"/>
 <xsl:apply-templates select="d:corpauthor" mode="bibtex"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:author|d:corpauthor" mode="raw">
<!--
1er auteur Nom, prnom les autres Prenom Nom
une virgule entre les auteurs sauf entre les deux derniers
-->
  <xsl:if test="d:personname/d:surname = ''">
   <xsl:message>
eee : empty surname for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
   </xsl:message>
  </xsl:if>
  <xsl:if test="d:personname/d:firstname= ''">
   <xsl:message>
eee : empty firstname for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
   </xsl:message>
  </xsl:if>
  <xsl:if test="d:personname/d:firstname= '.'">
   <xsl:message>
eee : firstname = '.' for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
   </xsl:message>
  </xsl:if>
<!--
   <xsl:message>
position de l'auteur <xsl:value-of select="d:personname/d:surname"/> :
<xsl:value-of select="position()"/> / <xsl:value-of select="count(following-sibling::*)"/>
</xsl:message>
-->

  <xsl:choose>
   <xsl:when test="position()=1">
    <xsl:value-of select="d:personname/d:surname"/><xsl:text>, </xsl:text>
    <xsl:value-of select="d:personname/d:firstname"/>
   </xsl:when>
   <xsl:otherwise>
    <xsl:value-of select="d:personname/d:firstname"/><xsl:text> </xsl:text>
    <xsl:value-of select="d:personname/d:surname"/>
   </xsl:otherwise>
  </xsl:choose>

<!--
une virgule entre les auteurs sauf entre les deux derniers
-->
  <xsl:choose>
   <xsl:when test="count(following-sibling::*)  &gt; 1"> <!-- plusieurs suivants -->
    <xsl:text>, </xsl:text>
   </xsl:when>
   <xsl:when test="count(following-sibling::*)  = 1">
<!--
   <xsl:message>ANDDDDD</xsl:message>
-->
    <!-- un suivant -->
    <xsl:call-template name="and">
     <xsl:with-param name="language" select="/d:bibliography/@xml:lang"/>
    </xsl:call-template>
   </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template match="d:author|d:corpauthor" mode="bibtex">
<!--
1er auteur Nom prnom les autres Prenom Nom
and entre les auteurs
-->
 <xsl:value-of select="d:personname/d:firstname"/><xsl:text> </xsl:text>
 <xsl:value-of select="d:personname/d:surname"/>

<!--
and entre les auteurs
-->
  <xsl:choose>
   <xsl:when test="count(following-sibling::*)  &gt; 0"> <!-- un suivant-->
    <xsl:text> and </xsl:text>
   </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template match="d:biblioentry/d:title" mode="raw">
 <xsl:text> : </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:biblioentry/d:title" mode="bibtex">
 <xsl:text>, title = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioset[@relation='journal']/d:title" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:biblioset[@relation='journal']/d:title" mode="bibtex">
 <xsl:text>, journal = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioset[@relation='conference']/d:title" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:biblioset[@relation='conference']/d:title" mode="bibtex">
 <xsl:text>, booktitle = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:publishername" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:publishername" mode="bibtex">
 <xsl:text>, publisher = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:pubdate" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:pubdate" mode="bibtex">
 <xsl:text>, year = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:date">
 <xsl:message terminate="no">
   eee : date
   <xsl:value-of select="normalize-space(.)"/> exists in node
   <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
   eee : try to put information in biblioset
 </xsl:message>
</xsl:template>

<xsl:template match="d:volumenum" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:volumenum" mode="bibtex">
 <xsl:text>, volume = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:issuenum" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:issuenum" mode="bibtex">
 <xsl:text>, number = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:pagenums" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:pagenums" mode="bibtex">
 <xsl:text>, pages = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioid[@class='isbn']" mode="raw">
 <xsl:text>, ISBN : </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:biblioid[@class='isbn']" mode="bibtex">
 <xsl:text>, isbn = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioid[@class='uri']" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:element name="link">
  <xsl:attribute name="xl:href"><xsl:value-of select="normalize-space(.)"/></xsl:attribute>
 </xsl:element>
</xsl:template>

<xsl:template match="d:biblioid[@class='uri']" mode="bibtex">
 <xsl:text>, uri = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioid[@class='other']" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="@otherclass"/>
 <xsl:text> : </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:biblioid[@class='other']" mode="bibtex">
 <xsl:text>, note = {</xsl:text>
 <xsl:value-of select="@otherclass"/>
 <xsl:text> : </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioid[@class='doi']" mode="bibtex">
   <xsl:choose>
    <xsl:when test=". = '???'">
     <xsl:message> iii : no doi found for
      <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
     </xsl:message>
    </xsl:when>
    <xsl:otherwise>
     <!-- ++ transformer 10.1029/2003GL018906 en un lien sur http://dx.doi.org/10.1029/2003GL018906 par exemple
  -->
      <xsl:text>, doi = {</xsl:text> <!-- ++ pas sre, peut-tre seulement note = {doi:..} -->
      <xsl:value-of select="normalize-space(.)"/>
    </xsl:otherwise>
   </xsl:choose>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioid[@class='doi']" mode="raw">
   <xsl:choose>
    <xsl:when test=". = '???'">
     <xsl:message> iii : no doi found for
      <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
     </xsl:message>
    </xsl:when>
    <xsl:otherwise>
     <!-- transformer 10.1029/2003GL018906 en un lien sur http://dx.doi.org/10.1029/2003GL018906 par exemple -->
     <xsl:text>, </xsl:text>
     <xsl:element name="link">
      <xsl:attribute name="xl:href">
       <xsl:text>http://dx.doi.org/</xsl:text>
       <xsl:value-of select="normalize-space(.)"/>
      </xsl:attribute>
      <xsl:text>doi:</xsl:text><xsl:value-of select="normalize-space(.)"/>
     </xsl:element>
    </xsl:otherwise>
   </xsl:choose>
</xsl:template>


<xsl:template match="d:conftitle">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:confdates">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:confnum">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:address" mode="raw">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<xsl:template match="d:address" mode="bibtex">
 <xsl:text>, address = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:template>

<xsl:template match="d:biblioid" mode="raw">
<xsl:choose>
<xsl:when test="@class='doi'">
 <xsl:apply-templates select="." mode="raw"/>
</xsl:when>
<xsl:when test="@class='isbn'">
 <xsl:apply-templates select="." mode="raw"/>
</xsl:when>
<xsl:when test="@class='uri'">
 <xsl:apply-templates select="." mode="raw"/>
</xsl:when>
<xsl:when test="@class='other'">
 <xsl:apply-templates select="." mode="raw"/>
</xsl:when>
<xsl:otherwise>
 <xsl:message terminate="yes">
eee : unknown biblioid class for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
eee : class : <xsl:value-of select="normalize-space(@class)"/>
eee : value : <xsl:value-of select="normalize-space(.)"/>
 </xsl:message>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="d:biblioid" mode="bibtex">
<xsl:choose>
<xsl:when test="@class='doi'">
 <xsl:apply-templates select="." mode="bibtex"/>
</xsl:when>
<xsl:when test="@class='isbn'">
 <xsl:apply-templates select="." mode="bibtex"/>
</xsl:when>
<xsl:when test="@class='uri'">
 <xsl:apply-templates select="." mode="bibtex"/>
</xsl:when>
<xsl:when test="@class='other'">
 <xsl:apply-templates select="." mode="bibtex"/>
</xsl:when>
<xsl:otherwise>
 <xsl:message terminate="yes">
eee : unknown biblioid class for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
eee : class : <xsl:value-of select="normalize-space(@class)"/>
eee : value : <xsl:value-of select="normalize-space(.)"/>
 </xsl:message>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="d:bibliomisc" mode="raw">
<xsl:choose>
<xsl:when test="contains(.,'In Press') or contains(.,'In press') or contains(.,'in press') or contains(.,'in revision') or contains(.,'submitted')">
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:when>
<xsl:otherwise>
 <xsl:message terminate="no">
eee : unknown bibliomisc purpose for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
eee : <xsl:value-of select="normalize-space(.)"/>
 </xsl:message>
 <xsl:text>, </xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="d:bibliomisc" mode="bibtex">
<xsl:choose>
<xsl:when test="contains(.,'In Press') or contains(.,'In press') or contains(.,'in press') or contains(.,'in revision') or contains(.,'submitted')">
   <xsl:text>, note = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
   <xsl:text>}</xsl:text>
</xsl:when>
<xsl:otherwise>
 <xsl:message terminate="no">
eee : unknown bibliomisc purpose for <xsl:value-of select="ancestor::d:biblioentry/@xml:id"/>
eee : <xsl:value-of select="normalize-space(.)"/>
 </xsl:message>
 <xsl:text>, note = {</xsl:text>
 <xsl:value-of select="normalize-space(.)"/>
 <xsl:text>}</xsl:text>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>
